<?php
class ControllerExtensionModuleBooking extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/booking');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('booking', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_login'] = $this->language->get('entry_login');
		$data['entry_pass'] = $this->language->get('entry_pass');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/booking', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/module/booking', 'token=' . $this->session->data['token'], true);
		$data['permition'] = $this->url->link('extension/module/booking/permition', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->post['booking_status'])) {
			$data['booking_status'] = $this->request->post['booking_status'];
		} else {
			$data['booking_status'] = $this->config->get('booking_status');
		}

		if (isset($this->request->post['booking_login'])) {
			$data['booking_login'] = $this->request->post['booking_login'];
		} else {
			$data['booking_login'] = $this->config->get('booking_login');
		}

		if (isset($this->request->post['booking_pass'])) {
			$data['booking_pass'] = $this->request->post['booking_pass'];
		} else {
			$data['booking_pass'] = $this->config->get('booking_pass');
		}

		if (isset($this->request->post['voucher_sort_order'])) {
			$data['booking_sort_order'] = $this->request->post['booking_sort_order'];
		} else {
			$data['booking_sort_order'] = $this->config->get('booking_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/booking', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/booking')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function install() {
		// Register the event triggers
		$this->load->model('extension/event');

		$this->model_extension_event->addEvent('booking', 'catalog/controller/product/product/index/before', 'extension/module/booking/sinchronization');
	}

	public function permition() {
		$this->load->language('extension/module/booking');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');
		$this->load->model('extension/module/booking');

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			$this->model_extension_module_booking->auth($this->request->post['ses'], $this->request->post['booking_login']);
			$this->response->redirect($this->url->link('extension/module/booking', 'token=' . $this->session->data['token'], true));
		} else {
			
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');

		$data['entry_login'] = $this->language->get('entry_login');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/booking', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/module/booking/permition', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		$data['booking_login'] = '';

		
		$data['ses'] = $this->model_extension_module_booking->login();

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/booking_validate', $data));
	}

	public function uninstall() {
		// delete the event triggers
		$this->load->model('extension/event');

		$this->model_extension_event->deleteEvent('booking');
	}
}
